/**************************************************************************
** defuze.me Epitech Innovative Project
**
** Copyright 2010
**   Athena Calmettes - Jocelyn De La Rosa - Francois Gaillard
**   Adrien Jarthon - Alexandre Moore - Luc Peres - Arnaud Sellier
**
** All rights reserved.
**************************************************************************/

class Core;

#ifndef CORE_HPP
#define CORE_HPP

#include "cores.hpp"

/** Abstract class inherited by all CORES.
  *
  * It contain 2 methods handling CORES loading and releasing.
  * - init() is called at start-up after all CORES are loaded, contrary to the constructor.
  * - aboutToQuit() is called before quit, when all CORES are still loaded, contrary to the destuctor.
  **/

class Core
{
public:
	/** Called once, after all CORES are loaded.
	  * \param cores The already loaded CORES.
	  **/
	virtual void init(Cores *cores) = 0;

	/** Called just before to quit, when CORES are still loaded.
	  **/
	virtual void aboutToQuit() = 0;

protected:
	Cores		*cores;				///< This will store the cores pointer so the core can use any other cores
};

#endif // CORE_HPP
