import QtQuick 1.0
import "globals.js" as Globals

Rectangle {
	id: lastfmView
	width: 400							/// Only used by the designer
	height: 400							/// Size will be automatically adjust to the underlying QDeclarativeView
	color: Globals.background_color

	property string user: login_page.login
	property bool connected: login_page.connected
	property string session_key: login_page.key
	property string api_key: "89dd449ff72a59735757e626d3c4b66a"
	property string secret: "8e2bb5475e973555c32829b589fc0e4f"
	property string country: "France"
	property string metro: "Paris"

	states: [
		State {
			name: "not_logged"
			PropertyChanges {
				target: view
				interactive: false
			}
			PropertyChanges {
				target: nav
				height: 0
				opacity: 0
				enabled: false
			}
			when: user.length === 0 || connected === false
		}
	]

	VisualItemModel {
		id: panesModel
		LoginPage { id: login_page ; width: view.width ; height : view.height }
		LastfmPage { width: view.width ; height : view.height
			PageTitle {
				title: "Search"
				description: "Browse through the whole world of music"
			}}
		WhatsNext { width: view.width ; height : view.height }
		RecentTracks { width: view.width ; height : view.height }
		YourCharts { width: view.width ; height : view.height }
		GlobalCharts { width: view.width ; height : view.height }
	}

	ListView {
		id: view
		x:0
		y:0
		width: parent.width
		height: parent.height - 30
		model: panesModel
		highlightMoveDuration: 500
		focus: true
		interactive: true
		orientation: ListView.Horizontal
		highlightRangeMode: ListView.StrictlyEnforceRange
		snapMode: ListView.SnapOneItem
		highlightFollowsCurrentItem:true
		boundsBehavior: Flickable.DragOverBounds
	}

	Rectangle {
		id: nav
		width: parent.width; height: 30
		anchors {bottom: parent.bottom}
		color: "gray"
		property int current: view.currentIndex
		Behavior on height { PropertyAnimation {} }
		Behavior on opacity { PropertyAnimation {} }

		ListModel {
			id: icons_model
			ListElement { name: "wrench" }
			ListElement { name: "find" }
			ListElement { name: "star" }
			ListElement { name: "time" }
			ListElement { name: "chart" }
			ListElement { name: "world" }
		}

		Row {
			anchors.centerIn: parent
			spacing: 20

			Repeater {
				model: panesModel.count

				Rectangle {
					width: 20; height: 20
					radius: 3
					color: nav.current == index ? Qt.lighter(nav.color) : nav.color

					Image {
						source: "qrc:/icons/" + icons_model.get(index).name
						anchors.centerIn: parent
					}

					MouseArea {
						width: 20; height: nav.height - 10
						anchors.centerIn: parent
						onClicked: view.currentIndex = index
					}
				}
			}
		}
	}
}
