/**************************************************************************
** defuze.me Epitech Innovative Project
**
** Copyright 2010-2012
**   Athena Calmettes - Jocelyn De La Rosa - Francois Gaillard
**   Adrien Jarthon - Alexandre Moore - Luc Peres - Arnaud Sellier
**
** All rights reserved.
**************************************************************************/

#ifndef LISTSITEM_HPP
#define LISTSITEM_HPP

#include "editabletreeitem.hpp"
#include <QPixmap>
#include <QPushButton>

namespace Lists
{
	class ListsModel;

	class ListsItem : public EditableTreeItem
	{
	public:
		enum Kind {
			CATEGORY, ADD, PLAYLIST, PARAMETER, SEPARATOR
		};
		enum SubKind {
			INVALID_SUBKIND, NORMAL_PLAYLIST, DYNAMIC_PLAYLIST, ADD_NORMAL, ADD_DYNAMIC, GENRE, ALBUM, ARTIST, TRACK, AND, INTRO
		};

		ListsItem(const QString &title, QPixmap icon, ListsModel *model, EditableTreeItem *parent = 0);
		bool insertChildren(int position, int count, int columns);
		ListsItem *child(int number);

		Kind getKind() const;
		SubKind getSubKind() const;
		void setKind(Kind kind);
		void setSubKind(SubKind subKind);
		ListsModel *getModel() const;
		bool isOfKind(Kind _kind);
		bool isOfKind(Kind _kind, SubKind _subKind);
		unsigned int getId() const;
		void setId(unsigned int id);

	private:
		QPixmap icon;
		ListsModel *model;
		Kind kind;
		SubKind subKind;
		unsigned int id;
	};

}

#endif // LISTSITEM_HPP
