/**************************************************************************
** defuze.me Epitech Innovative Project
**
** Copyright 2010-2011
**   Athena Calmettes - Jocelyn De La Rosa - Francois Gaillard
**   Adrien Jarthon - Alexandre Moore - Luc Peres - Arnaud Sellier
**
** All rights reserved.
**************************************************************************/

#include "audioeffectvolumewidget.hpp"

AudioEffectVolumeWidget::AudioEffectVolumeWidget(Audio::AudioEffectVolume *effect, QWidget *parent) :
	AudioEffectWidget(effect, parent)
{
	setupUi(this);
	effectNameLabel->setText("Volume");
	muteButton->setIcon(this->style()->standardIcon(QStyle::SP_MediaVolume));
	_isMuted = false;
	volumeSlider->setValue(static_cast<Audio::AudioEffectVolume*>(effect)->volume());
}

void AudioEffectVolumeWidget::on_muteButton_clicked()
{
	if (_isMuted == true)
	{
		_isMuted = false;
		muteButton->setIcon(this->style()->standardIcon(QStyle::SP_MediaVolume));
		volumeSlider->setDisabled(false);
		static_cast<Audio::AudioEffectVolume*>(effect)->volume() = volumeSlider->value();
	}
	else
	{
		_isMuted = true;
		muteButton->setIcon(this->style()->standardIcon(QStyle::SP_MediaVolumeMuted));
		volumeSlider->setDisabled(true);
		static_cast<Audio::AudioEffectVolume*>(effect)->volume() = 0;
	}
}

void	AudioEffectVolumeWidget::setVolume(int volume)
{
	volumeSlider->setValue(volume);
}

void	AudioEffectVolumeWidget::setLevels(double left, double right)
{
	vumeter->setLevels(left, right);
}

void AudioEffectVolumeWidget::on_volumeSlider_valueChanged(int position)
{
	static_cast<Audio::AudioEffectVolume*>(effect)->volume() = position;
}
