import QtQuick 1.0
import "globals.js" as Globals

Rectangle {
	id: lastfmView
	width: 400							/// Only used by the designer
	height: 400							/// Size will be automatically adjust to the underlying QDeclarativeView
	color: Globals.background_color

	signal logged()

	Timer {
		id: tmp_timer
		interval: 1000; running: false; repeat: false
		onTriggered: view.incrementCurrentIndex()
	}

	Text { id: time }

	onLogged: {
		tmp_timer.start()
	}

	VisualItemModel {
		id: panesModel
		LoginPage {
			id: login_page
			width: view.width
			height : view.height
			onJustLogged: logged()
		}
		YourCharts { width: view.width ; height : view.height }
		GlobalCharts { width: view.width ; height : view.height }
		RecentTracks { width: view.width ; height : view.height }
	}

	ListView {
		id: view
		x:0
		y:0
		width: parent.width
		height: parent.height - 30
		model: panesModel
		highlightMoveDuration: 500
		focus: true
		interactive: true
		orientation: ListView.Horizontal
		highlightRangeMode: ListView.StrictlyEnforceRange
		snapMode: ListView.SnapOneItem
		highlightFollowsCurrentItem:true
		boundsBehavior: Flickable.DragOverBounds
	}

	Rectangle {
		id: nav
		width: parent.width; height: 30
		anchors { top: view.bottom ; bottom: parent.bottom }
		color: "gray"
		property int current: view.currentIndex

		Row {
			anchors.centerIn: parent
			spacing: 20

			Repeater {
				model: panesModel.count

				Rectangle {
					width: 5; height: 5
					radius: 3
					color: nav.current == index ? "blue" : "white"

					MouseArea {
						width: 20; height: 20
						anchors.centerIn: parent
						onClicked: view.currentIndex = index
					}
				}
			}
		}
	}
}
