import QtQuick 1.0
import "helper.js" as Helper

LastfmPage {
	id: login_page
	signal justLogged()

	onJustLogged: {
		console.log("Go!")
		state = "waiting"
	}

	states: [
		State {
			name: "waiting"
			PropertyChanges {
				target: rectangle
				opacity: 0
			}
			PropertyChanges {
				target: go_rectangle
				opacity: 0
			}
		}
	]

	Rectangle {
		id: rectangle
		x: 81
		y: 70
		width: 162
		height: 120
		color: Qt.darker(parent.color)
		radius: 4
		anchors.horizontalCenter: parent.horizontalCenter
		anchors.verticalCenter: parent.verticalCenter
		border.color: color

		Behavior on opacity { PropertyAnimation {duration: 1000} }

		Image {
			id: image1
			height: 45
			anchors.top: parent.top
			anchors.topMargin: 8
			anchors.right: parent.right
			anchors.rightMargin: 8
			anchors.left: parent.left
			anchors.leftMargin: 8
			source: "http://cdn.last.fm/flatness/badges/lastfm_red.gif"
		}

		Text {
			id: text1
			y: 62
			color: "#ffffff"
			text: qsTr("Type your last.fm login")
			font.bold: true
			horizontalAlignment: Text.AlignHCenter
			verticalAlignment: Text.AlignVCenter
			anchors.right: parent.right
			anchors.rightMargin: 8
			anchors.left: parent.left
			anchors.leftMargin: 8
			font.pixelSize: 12
		}

		LineEdit {
			x: 8
			y: 85
			width: 146
			height: 27
			border.width: 0
			anchors.right: parent.right
			anchors.rightMargin: 8
			anchors.left: parent.left
			anchors.leftMargin: 8
			anchors.bottom: parent.bottom
			anchors.bottomMargin: 8
			size: 16

		}
	}

	Rectangle {
		id: go_rectangle
		x: 178
		width: 45
		height: 45
		color: rectangle.color
		radius: 4
		border.color: color
		anchors.horizontalCenterOffset: 0
		anchors.top: rectangle.bottom
		anchors.topMargin: 10
		anchors.horizontalCenter: parent.horizontalCenter

		Behavior on opacity { PropertyAnimation {duration: 1000} }

		Text {
			id: text2
			color: "#ffffff"
			text: qsTr("Go")
			font.bold: true
			horizontalAlignment: Text.AlignHCenter
			verticalAlignment: Text.AlignVCenter
			anchors.rightMargin: 2
			anchors.leftMargin: 2
			anchors.bottomMargin: 2
			anchors.topMargin: 2
			anchors.fill: parent
			font.pixelSize: 24
		}

		MouseArea {
			id: submit_area
			anchors.fill: parent
			onClicked: justLogged()
		}
	}
}
