import QtQuick 1.0
import "globals.js" as Globals

Rectangle {
	id: page_title
	z: 1
	width: parent.width
	height: 42
	gradient: Gradient {
		GradientStop {
			position: 0
			color: Globals.title_gradient_top
		}

		GradientStop {
			position: 0.680
			color: Globals.title_gradient_bottom
		}
	}

	property string title
	property string description

	Text {
		id: title
		height: 28
		color: Globals.title_text_color
		text: page_title.title
		font.bold: true
		verticalAlignment: Text.AlignVCenter
		horizontalAlignment: Text.AlignLeft
		anchors.top: parent.top
		anchors.topMargin: 0
		anchors.right: parent.right
		anchors.rightMargin: 0
		anchors.left: parent.left
		anchors.leftMargin: 5
		font.pixelSize: 20
	}

	Text {
		id: description
		y: 48
		height: 12
		color: Globals.title_description_color
		text: page_title.description
		verticalAlignment: Text.AlignVCenter
		anchors.right: parent.right
		anchors.rightMargin: 0
		anchors.left: parent.left
		anchors.leftMargin: 5
		anchors.bottom: parent.bottom
		anchors.bottomMargin: 2
		font.pixelSize: 12
	}

	Image {
		id: logo
		width: 80
		height: 28
		anchors.top: parent.top
		anchors.topMargin: 5
		anchors.right: parent.right
		anchors.rightMargin: 5
		fillMode: Image.PreserveAspectFit
		sourceSize.height: 28
		sourceSize.width: 80
		source: Globals.lastfm_black_logo
	}
}
