/**************************************************************************
** defuze.me Epitech Innovative Project
**
** Copyright 2010
**   Athena Calmettes - Jocelyn De La Rosa - Francois Gaillard
**   Adrien Jarthon - Alexandre Moore - Luc Peres - Arnaud Sellier
**
** All rights reserved.
**************************************************************************/

#ifndef LOGGER_HPP
#define LOGGER_HPP

#include "singleton.hpp"
#include <QtCore/QFile>
#include <QDesktopServices>

const static QString gl_MAIN_LOG_DIR = "/logs";														///< Log directory
const static QString gl_MAIN_LOG_FILE = "log";														///< Log file name
const static QString gl_MAIN_LOG_EXT = "txt";														///< Log file extension

/** The tool to write logs
  *
  * The singleton instance is used to write log in a log file.
  * The log file is defined by:
  * - gl_MAIN_LOG_DIR
  * - gl_MAIN_LOG_FILE
  * - "YYYYMMDD"
  * - gl_MAIN_LOG_EXT
  *
  * You have to use the static method log() as follow:
  * \code
  * Logger::log("You message."); // NewLine character will be added.
  * \endcode
  **/

class Logger : public Singleton<Logger>
{
	friend class Singleton<Logger>;
public:
	static void log(const QString &message);														///< Write message into log file

protected:
	Logger();
	~Logger();

private:
	void updateLog(QString msg) const;
	QByteArray logHeader() const;
	QString logFileName() const;
	QFile *logFile;
};

#endif // LOGGER_HPP
