/**************************************************************************
** defuze.me Epitech Innovative Project
**
** Copyright 2010-2012
**   Athena Calmettes - Jocelyn De La Rosa - Francois Gaillard
**   Adrien Jarthon - Alexandre Moore - Luc Peres - Arnaud Sellier
**
** All rights reserved.
**************************************************************************/

#ifndef EDITABLETREEMODEL_HPP
#define EDITABLETREEMODEL_HPP

#include <QAbstractItemModel>
#include <QModelIndex>
#include <QVariant>

class EditableTreeItem;

class EditableTreeModel : public QAbstractItemModel
{
	Q_OBJECT

public:
	EditableTreeModel(QObject *parent = 0);
	~EditableTreeModel();

	QVariant data(const QModelIndex &index, int role) const;
	QVariant headerData(int section, Qt::Orientation orientation,
						int role = Qt::DisplayRole) const;

	QModelIndex index(int row, int column,
					  const QModelIndex &parent = QModelIndex()) const;
	QModelIndex parent(const QModelIndex &index) const;

	int rowCount(const QModelIndex &parent = QModelIndex()) const;
	int columnCount(const QModelIndex &parent = QModelIndex()) const;

	Qt::ItemFlags flags(const QModelIndex &index) const;
	bool setData(const QModelIndex &index, const QVariant &value,
				 int role = Qt::EditRole);
	bool setHeaderData(int section, Qt::Orientation orientation,
					   const QVariant &value, int role = Qt::EditRole);

	bool insertColumns(int position, int columns,
					   const QModelIndex &parent = QModelIndex());
	bool removeColumns(int position, int columns,
					   const QModelIndex &parent = QModelIndex());
	bool insertRows(int position, int rows,
					const QModelIndex &parent = QModelIndex());
	bool removeRows(int position, int rows,
					const QModelIndex &parent = QModelIndex());

protected:
	void setupModelData(const QStringList &lines, EditableTreeItem *parent);
	EditableTreeItem *getItem(const QModelIndex &index) const;

	EditableTreeItem *rootItem;
};

#endif // EDITABLETREEMODEL_HPP
