package com.defuzeme.communication;

import java.util.ArrayList;
import java.util.Vector;

import com.defuzeme.DefuzeMe;
import com.defuzeme.R.string;

import android.content.pm.PackageManager.NameNotFoundException;
import android.os.IBinder;
import android.util.Log;

@SuppressWarnings("unused")
public class Receive {

	private DefuzeMe		_application	= null;
	
	public Receive(DefuzeMe application) {
		this._application	= application;
		DefuzeMe._requests	= new Vector<StreamObject>();
	}

	/*
	 * Actions methods
	 */
	public void ok(StreamObject object) {}

	public void authenticationRequest(StreamObject object) {
	    DefuzeMe._handler.post(DefuzeMe.Gui.showAuthenticatingProgress);
	    Communication.Send.sendAuthenticationObject(object);
	}

	public void authenticated(StreamObject object) {
		DefuzeMe.Gui.hideProgress();
	}
	
	public void authenticationFailed(StreamObject object) {
		DefuzeMe.Gui.hideProgress();
		DefuzeMe._handler.post(DefuzeMe.Gui.toastAuthenticationFailed);
		DefuzeMe._handler.post(DefuzeMe.Network.disconnect);
	}
	
	public void newQueueElem(StreamObject object) {
		Integer position	= object.getData().getPosition();
		DefuzeMe._queueTracks.add(object.getData().getPosition(), object);
	}
	
	public void popQueue(StreamObject object) {
		/*
		 * Don't use popQueue,
		 * removeQueueElem do all the job
		 */
		
		/*
		if (DefuzeMe._queueTracks.get(0) != null) {
			DefuzeMe._queueTracks.remove(0);
		}
		*/
	}

	public void removeQueueElem(StreamObject object) {
		int index	= object.getData().getPosition();
		
		if (DefuzeMe._queueTracks.get(object.getData().getPosition()) != null) {
			if (DefuzeMe._queueTracks.remove(index) == null) {
				Log.e(this.getClass().getName(), "Can't remove item Queue Track item");
			}
		}
	}
	
	public void play(StreamObject object) {
		DefuzeMe._playingStatus = true;
	}
	
	public void pause(StreamObject object) {
		DefuzeMe._playingStatus = false;
	}
	
	/*
	 * Re-index positions
	 */
	public void reIndex() {
		for (int index = 0; index < DefuzeMe._queueTracks.size(); index += 1) {
			StreamObject newObject	= DefuzeMe._queueTracks.get(index);
			newObject.getData().setPosition(index);
			DefuzeMe._queueTracks.set(index, newObject);
		}
	 }
	
}
